"{ Package: 'jv:cface' }"

"{ NameSpace: Cface }"

CTypeNode subclass:#CTypedefNode
	instanceVariableNames:'type foreign'
	classVariableNames:''
	poolDictionaries:''
	category:'Cface-C AST'
!

!CTypedefNode class methodsFor:'documentation'!

history

    "Created: / 25-10-2007 / 15:07:10 / haja"
    "Created: #local / 25-10-2007 / 15:07:18 / haja"
    "Created: #local: / 25-10-2007 / 15:07:18 / haja"
    "Created: #names / 25-10-2007 / 15:07:18 / haja"
    "Created: #names: / 25-10-2007 / 15:07:18 / haja"
    "Created: #local:names: / 25-10-2007 / 15:08:27 / haja"
    "Deleted: #local / 29-10-2007 / 19:58:35 / haja"
    "Deleted: #local: / 29-10-2007 / 19:58:35 / haja"
    "Deleted: #names / 29-10-2007 / 19:58:35 / haja"
    "Deleted: #names: / 29-10-2007 / 19:58:35 / haja"
    "Created: #name / 29-10-2007 / 19:58:43 / haja"
    "Created: #name: / 29-10-2007 / 19:58:43 / haja"
    "Created: #id / 29-10-2007 / 19:58:43 / haja"
    "Created: #id: / 29-10-2007 / 19:58:43 / haja"
    "Created: #name:id: / 29-10-2007 / 19:59:29 / haja"
    "Deleted: #local:names: / 29-10-2007 / 19:59:43 / haja"
    "Created: #acceptVisitor: / 02-11-2007 / 10:46:04 / haja"
    "Created: #foreign / 19-11-2007 / 09:41:32 / haja"
    "Created: #foreign: / 19-11-2007 / 09:41:32 / haja"
    "Created: #name:id:foreign: / 19-11-2007 / 09:41:41 / haja"
    "Deleted: #name:id: / 19-11-2007 / 09:41:43 / haja"
! !

!CTypedefNode methodsFor:'accessing'!

cByteSize

    ^type cByteSize

    "Created: / 09-07-2008 / 19:39:38 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

ffiTypeSymbol

    ^type ffiTypeSymbol

    "Created: / 03-07-2008 / 22:40:25 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

foreign
    ^ foreign

    "Created: / 04-07-2008 / 11:46:03 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

foreign:something
    foreign := something.

    "Created: / 04-07-2008 / 11:46:03 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

type
    ^ type

    "Created: / 10-02-2008 / 19:23:13 / janfrog"
!

type:something
    type := something.

    "Created: / 10-02-2008 / 19:23:13 / janfrog"
! !

!CTypedefNode methodsFor:'printing'!

printOn: stream indent: level

    self printLineOn: stream indent: level.
    stream
        nextPutAll: '(typedef '; cr;
        next: level + 1 put: Character tab; nextPutAll: cName; cr;
        next: level + 1 put: Character tab.
    type printOn: stream indent: level + 1.
    stream nextPut: $)

    "Created: / 17-02-2008 / 18:13:13 / janfrog"
    "Modified: / 18-02-2008 / 15:12:01 / janfrog"
    "Modified: / 10-07-2008 / 20:05:26 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!CTypedefNode methodsFor:'testing'!

isForeign

    ^foreign ? false

    "Created: / 04-07-2008 / 11:46:39 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!CTypedefNode methodsFor:'visiting'!

acceptVisitor:aVisitor 
    "Double dispatch back to the visitor, passing my type encoded in
     the selector (visitor pattern)"
    "stub code automatically generated - please change if required"
    
    ^ aVisitor visitCTypedefNode:self

    "Created: / 02-11-2007 / 10:46:04 / haja"
    "Modified: / 10-02-2008 / 10:45:50 / janfrog"
! !

!CTypedefNode class methodsFor:'documentation'!

version
    ^ '$Id$'
!

version_SVN
    ^ '$Id$'
! !
